classesToNumbers={[Turbine.Gameplay.Class.Beorning]=1,[Turbine.Gameplay.Class.Burglar]=2,[Turbine.Gameplay.Class.Captain]=3,[Turbine.Gameplay.Class.Champion]=4,[Turbine.Gameplay.Class.Guardian]=5,[Turbine.Gameplay.Class.Hunter]=6,[Turbine.Gameplay.Class.LoreMaster]=7,[Turbine.Gameplay.Class.Minstrel]=8,[Turbine.Gameplay.Class.RuneKeeper]=9,[Turbine.Gameplay.Class.Warden]=10,[Turbine.Gameplay.Class.Reaver]=11,[Turbine.Gameplay.Class.Defiler]=12,[Turbine.Gameplay.Class.Stalker]=12,[Turbine.Gameplay.Class.Weaver]=13,[Turbine.Gameplay.Class.BlackArrow]=14,[Turbine.Gameplay.Class.WarLeader]=15}
numbersToClasses={"Beorning","Burglar","Captain","Champion","Guardian","Hunter","Lore Master","Minstrel","Rune Keeper","Warden"}
statOrder={"Level","Class","Morale","Power","ICMR","ICPR","Armor","Might","Agility","Vitality","Will","Fate","CritRate","Finesse","PhysMast","TactMast","OutHeals","Resistance","CritDef","IncHeals","Block","Parry","Evade","CommonMit","PhysMit","TactMit"}
function selfStats()
	localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance()
	localPlayer.attr=localPlayer:GetAttributes()
	localPlayerName=localPlayer:GetName()
	player={}

    player["Morale"]     = localPlayer:GetMaxMorale()
    player["Power"]      = localPlayer:GetMaxPower()
    player["ICMR"]       = localPlayer.attr:GetInCombatMoraleRegeneration()
    player["ICPR"]       = localPlayer.attr:GetInCombatPowerRegeneration()

    player["Armor"]      = localPlayer.attr:GetArmor()
    player["Might"]      = localPlayer.attr:GetMight()
    player["Agility"]    = localPlayer.attr:GetAgility()
    player["Vitality"]   = localPlayer.attr:GetVitality()
    player["Will"]       = localPlayer.attr:GetWill()
    player["Fate"]       = localPlayer.attr:GetFate()

    player["CritRate"]   = localPlayer.attr:GetBaseCriticalHitChance()
    player["CritMag"]    = localPlayer.attr:GetBaseCriticalHitChance()
    player["DevRate"]    = localPlayer.attr:GetBaseCriticalHitChance()
    
    player["Finesse"]    = localPlayer.attr:GetFinesse()
    player["PhysMast"]   = math.max(localPlayer.attr:GetMeleeDamage(), localPlayer.attr:GetRangeDamage())
    player["TactMast"]   = localPlayer.attr:GetTacticalDamage()
    player["OutHeals"]   = localPlayer.attr:GetOutgoingHealing()

    player["Resistance"] = localPlayer.attr:GetBaseResistance()
    player["CritDef"]    = localPlayer.attr:GetBaseCriticalHitAvoidance()
    player["IncHeals"]   = localPlayer.attr:GetIncomingHealing()

    player["Block"]      = localPlayer.attr:CanBlock() and localPlayer.attr:GetBlock() or 0
    player["Parry"]      = localPlayer.attr:CanParry() and localPlayer.attr:GetParry() or 0
    player["Evade"]      = localPlayer.attr:CanEvade() and localPlayer.attr:GetEvade() or 0

    player["PartialBlock"] = localPlayer.attr:CanBlock() and localPlayer.attr:GetBlock() or nil

    player["PartialParry"] = localPlayer.attr:CanParry() and localPlayer.attr:GetParry() or nil

    player["PartialEvade"] = localPlayer.attr:CanEvade() and localPlayer.attr:GetEvade() or nil


    player["PartialBlockMit"] = localPlayer.attr:CanBlock() and localPlayer.attr:GetBlock() or nil
    player["PartialParryMit"] = localPlayer.attr:CanParry() and localPlayer.attr:GetParry() or nil
    player["PartialEvadeMit"] = localPlayer.attr:CanEvade() and localPlayer.attr:GetEvade() or nil


    player["CommonMit"]  = localPlayer.attr:GetCommonMitigation()
    player["PhysMit"]    = localPlayer.attr:GetPhysicalMitigation()
	--print(player["PhysMit"])
    player["TactMit"]    = localPlayer.attr:GetTacticalMitigation()
	player["Level"]=localPlayer:GetLevel()
	player["Class"]=classesToNumbers[localPlayer:GetClass()]
	for i in pairs(player) do
		player[i]=math.floor(player[i]+0.5)
		--print(player[i])
	end

end

local floor,insert = math.floor, table.insert
function basen(n,b)
    n = floor(n)
    if not b or b == 10 then return tostring(n) end
    local digits = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    local t = {}
    local sign = ""
    if n < 0 then
        sign = "-"
    n = -n
    end
    repeat
        local d = (n % b) + 1
        n = floor(n / b)
        insert(t, 1, digits:sub(d,d))
    until n == 0
    return sign .. table.concat(t,"")
end

function convertToHidden(p)
	--print(p)
	for i in pairs(p) do
		--print(p[i])
		--print(basen(p[i],15))
		--print(p[i])
		--print(i)
		p[i]=basen(tonumber(p[i]),15)
		--print(p[i])
	end
	local output
	output=""
	for i=1,#statOrder do
		--print(statOrder[i])
		output=output..p[statOrder[i]].."F"
	end
	while #output % 16 ~= 0 do
		output=output.."F"
	end
	output="<i></i>"..string.gsub(output,"(................)","<Select:IID:0x%1><\Select>").."<i></i>"
	--print(output)
	return output
end
function convertFromHidden(s)
	s=string.gsub(s,"%<Select%:IID%:0x(................)%>%<%\Select>","%1")
	--print(s)
	local c
	c=1
	local output
	output={}
	for i in string.gmatch(s, "[^F]+F") do
		output[statOrder[c]]=tonumber(string.gsub(i,"F",""),15)
		if statOrder[c] == "Class" then
			output[statOrder[c]]=numbersToClasses[output[statOrder[c]]]
		end
   		--print(i)
		--print(output[statOrder[c]])
		c=c+1
	end
	return output
	
end

viewStats=function(hidden,name)
	local output="Name: "..name
	local stats=convertFromHidden(hidden)
	local breaks={["Class"]=true,["ICPR"]=true,["Fate"]=true,["OutHeals"]=true}
	for i=1,#statOrder do
		output=output.."\n"..tostring(statOrder[i])..": "..tostring(stats[statOrder[i]])
		if breaks[statOrder[i]] ~= nil then
			output=output.."\n"
		end
	end
	inspectText:SetText(output)
	InspectWindow:SetZOrder(Window:GetZOrder()+1)
	InspectWindow:SetVisible(true)
end

selfStats()
